;;--------------------------------------------------------------------------;;
;;--------------------------------------------------------------------------;;
;;                       Font lock keywords
;;--------------------------------------------------------------------------;;

(defconst nedpg-font-lock-keywords
  (list
;commands
   '("(\\*\\([^*]\\|\\*+[^*)]\\)*\\(\\*+)\\|\\**$\\)"
    0 'font-lock-comment-face t)
   '("\"\\([^\\\"]\\|\\\\.\\)*\""
    0 'font-lock-string-face t)
    (cons (concat "\\([ \t]\\|^\\)\\("
       "const\\|"
       "with\\|"
       "var\\|"
       "def\\|"
       "lemma\\|"
       "axiom\\|"
       "type\\|"
       "help\\|"
       "print\\|"
       "undo\\|"
       "latex\\|"
       "save\\|"
       "reset\\|"
       "exit\\|"  
       "goal\\|"
       "\\)[ \t\n\r.]")
      '(0 'font-lock-keyword-face t))
;proof command
    (cons (concat "\\([ \t]\\|^\\)\\("
       "apply\\|"
       "elim\\|"
       "remove\\|"
       "instance\\|"
       "move\\|"
       "shift\\|"
       "intro\\|"
       "cut\\|"
       "pos\\|"
       "rew\\|"
       "insert\\|"
       "ref\\|"
       "sym\\|"
       "trans\\|"
       "simplify\\|"
       "lam\\|"
       "beta\\|"
       "eta\\|"
       "\\)[ \t.]")
      '(0 'font-lock-type-face t))))

;;--------------------------------------------------------------------------;;
;;--------------------------------------------------------------------------;;
;;                       nedpg-sym-lock tables
;;--------------------------------------------------------------------------;;

(if proof-running-on-XEmacs (require 'nedpg-sym-lock))

;; to change this table, xfd -fn '-adobe-symbol-*--12-*' may be
;; used to determine the symbol character codes.
(defconst nedpg-sym-lock-keywords-table
  '(("!=" 0 1 185)
    (":<" 0 1 206)
    ("[^:]\\(:\\)[^:= \n\t\r]" 1 7 206)
    ("/\\\\" 0 1 36)
    ("\\\\/" 0 1 34)
    ("+" 0 1 218) 
    ("\\<in\\>" 0 3 206) 
    ("\\<notin\\>" 0 4 207) 
    ("\\<inter\\>" 0 3 199) 
    ("\\<union\\>" 0 3 200) 
    ("\\<plus\\>" 0 3 43) 
    ("\\<minus\\>" 0 3 45) 
    ("\\<times\\>" 0 3 42) 
    ("\\<less\\>" 0 3 60)
    ("\\<lesseq\\>" 0 3 163)
    ("\\<greater\\>" 0 3 62)
    ("\\<greatereq\\>" 0 3 179)
    ("\\<TRUE\\>" 0 3 84)
    ("\\<FALSE\\>" 0 3 94)
    ("&" 0 1 217) 
    ("<=>" 0 1 171)
    ("=>" 0 1 222) 
    ("\\<subset\\>" 0 4 204)
    ("->" 0 1 174)
    ("~" 0 1 216)
    ("\\\\" 0 1 108)
    ("\\<epsilon\\>" 0 3 101)
    ("\\<delta\\>" 0 3 100)
))
;  "If non nil: Overrides default Nedpg-Sym-Lock patterns for Nedpg.")

(defun nedpg-sym-lock-start ()
	(if (and (featurep 'nedpg-sym-lock) nedpg-sym-lock)
	    (progn
	      (setq nedpg-sym-lock-color
		    (face-foreground 'font-lock-function-name-face))
	      (if (not nedpg-sym-lock-keywords)
		  (nedpg-sym-lock nedpg-sym-lock-keywords-table)))))

(provide 'nedpg-font)
