(* This Cut.sml File implements the Cut Rule
 i.e. :  A => C   is the same as:    A => B und B => C
 *)

local open Data Goal in

fun add formel goal = 
    let
	val pter = Goal.get_first_goal(goal)
	val (left,right) = 
	   ( case pter of
		IMP(l,r) => (l,r)
	      |_     => raise Error("Fehler in Cut Rule 1\n")
	   )
		
	val newpter = IMP(left, formel)
	val newgoal' = Goal.update_first_goal(goal,newpter)
	val newgoal = Goal.split_goal(newgoal',
				      IMP( ( case left of 
					    (C "TRUE") => formel 
					    | _ => AND(formel, left))  , right))
    in 
	newgoal 
    end




fun main(goal,f) = let 
		    val instinit = Goal.init_goal_env(goal)
		    val instgoal = Goal.first_goal(instinit,f)
		   
		    val formel' = Goal.get_first_goal(instgoal)
		    val formel  =( case formel' of
			          (IMP(C "TRUE", m)) => m
				    | _ => raise Error("Fehler Cut Rule\n")
				 )
		    val mergegoal = Goal.merge_envs(goal,instgoal)
		    val new_goal = add formel mergegoal
	      in
		  (Goal.print_goal(new_goal); new_goal)
	      end

end (* of local open *)

