(* Lambda.sml implementiert beta/eta Reduktionen 
 * innerhalb eines Ausdrucks 
 *)

local open Data Goal ETT in

fun red (C c) = C c
  | red (V x) = V x
  | red (GAMMA a) = GAMMA a
  | red (A(m,m')) = beta (red m) (red m')
  | red (L(t,m)) = eta t (red m)
  | red (EX(t,m))  = EX(t, red m)
  | red (ALL(t,m)) = ALL(t, red m)
  | red (AND(m,m')) = AND( red m, red m')
  | red (OR(m,m')) = OR(red m , red m')
  | red (IMP(m,m')) = IMP(red m , red m')
  | red (EQ(m,m')) = EQ(red m, red m')
  | red (NOT(m)) = NOT(red m)
and beta (L(t,m)) n = red (down 1 (sub m 0 (up 0 n 1)) 1)
  | beta m n = A(m,n)
and eta t (A(m,V 0)) = if not (free 0 m) then down 0 m 1 else L(t, A(m, V 0))
  | eta t m = L(t,m)


fun justbeta (A( L(t,m), n)) = down 1 (sub m 0 (up 0 n 1)) 1
  | justbeta p = p

fun justeta (p as (L(t, A(m,V 0)))) = if not (free 0 m) then (down 0 m 1) else p
  | justeta p = p

fun main(goal) = let 
		     val pter = Goal.get_first_goal(goal)
		     val redpter = red(pter)
		     val newgoal = Goal.update_first_goal(goal,redpter)
		 in 
		     (Goal.print_goal(newgoal) ; newgoal )
		 end

end (* of local open *)