(*  The Move.sml Modul implements the Equivalence of :
 *  B => ~A + (C + D)    <-->   A & B => C + D   <-->   ~C & ( A & B ) => D
 *)

local open Data Goal in

fun not (NOT(t)) = t
  | not t        = NOT(t)
    
    
fun smooth (t as (OR(a,b))) = 
    (case b of
	 (C("FALSE")) => a      (* a + FALSE = a *)
       | _            => t      (* gesamter Teilausdruck *)
	     )
	 
  | smooth ( t as AND(a,b)) = 
	 (case b of
	      (C("TRUE")) => a   
	    | _           => t )
  | smooth t = t

	      
fun mover2l (IMP(left, OR(a,b))) goal = 
    Goal.update_first_goal(goal, IMP(smooth(AND(not(a),left)), b) )

  | mover2l (IMP(left, a)) goal = 
    Goal.update_first_goal(goal, IMP(smooth(AND(not(a),left)), C "FALSE"))
  | mover2l _ goal = goal



fun movel2r ( IMP(AND(a,b),right) ) goal = 
	Goal.update_first_goal(goal, IMP(b,smooth(OR(not(a),right))))
  
  | movel2r ( IMP(a, right) ) goal =
	Goal.update_first_goal(goal, IMP(C "TRUE", smooth(OR(not(a),right))))

  | movel2r _ goal = goal
    


fun main(goal, d) = 
    let
	val pter = Goal.get_first_goal(goal)
	val newgoal = case d of 
	    LEFT  => movel2r pter goal
	  | RIGHT => mover2l pter goal
    in
	(Goal.print_goal(newgoal); newgoal)
    end

end



(* 
val _ = print ("(l)eft or (r)ight to move? :")
	val s = TextIO.inputLine TextIO.stdIn                      
	val (l,r) = 
	    case (String.sub (s,0)) of
*)