(* Position.sml 
 *)

local open Data Process in

exception internalerror

val initvmap = fn x:int => raise Error (" INIT VMAP ERROR !!(POSITION.SML) \n ")
fun cons(f,s) = fn x:int => if x = 0 then s else f(x-1)

fun javainput (C c)                l (fmap,bmap) vmap  = "C " ^ c ^" "
  | javainput (V x)                l (fmap,bmap) vmap  = "V " ^ (if ( x >= l ) then fmap (x-l) else vmap x) ^ " "
  | javainput (g as (GAMMA (_,i))) l (fmap,bmap) vmap  = "GAMMA " ^ Int.toString(i)  ^ " " 
  | javainput (A(m,m'))            l (fmap,bmap) vmap  = "APP {" ^ (javainput m  l (fmap,bmap) vmap) ^ "}" ^
                                                             "{" ^ (javainput m' l (fmap,bmap) vmap) ^ "}"
  | javainput (L((t,i),m))         l (fmap,bmap) vmap  = "LAM " ^ (bmap i ) ^ "{"
							 ^ ( javainput m (l+1) (fmap,bmap) (cons(vmap,bmap i)) ) ^"}" 
  | javainput (EX((t,i),m))        l (fmap,bmap) vmap  = "EX " ^ (bmap i ) ^ "{"
							 ^ ( javainput m (l+1) (fmap,bmap) (cons(vmap,bmap i)) ) ^"}"
  | javainput (ALL((t,i),m))       l (fmap,bmap) vmap  = "ALL " ^ (bmap i ) ^ "{"
							 ^ ( javainput m (l+1) (fmap,bmap) (cons(vmap,bmap i)) ) ^"}"
  | javainput (AND(m,m'))          l (fmap,bmap) vmap  = "AND {" ^ (javainput m  l (fmap,bmap) vmap) ^ "}" ^
                                                             "{" ^ (javainput m' l (fmap,bmap) vmap) ^ "}"
  | javainput (OR(m,m'))           l (fmap,bmap) vmap  = "OR {" ^ (javainput m  l (fmap,bmap) vmap) ^ "}" ^
                                                             "{" ^ (javainput m' l (fmap,bmap) vmap) ^ "}"
  | javainput (IMP(m,m'))          l (fmap,bmap) vmap  = "IMP {" ^ (javainput m  l (fmap,bmap) vmap) ^ "}" ^
                                                             "{" ^ (javainput m' l (fmap,bmap) vmap) ^ "}"
  | javainput (EQ(m,m'))           l (fmap,bmap) vmap  = "EQ {" ^ (javainput m  l (fmap,bmap) vmap)  ^ "}" ^
                                                             "{" ^ (javainput m' l (fmap,bmap) vmap) ^ "}"
  | javainput (NOT(m))             l (fmap,bmap) vmap  = "NOT {" ^ (javainput m  l (fmap,bmap) vmap) ^ "}" 

fun get_premisse (AND(a,b)) i = if i <= 1 then a else get_premisse b (i-1)
  | get_premisse t i = if i = 1 then t else raise internalerror

(* Prefix fuer Programm *)
fun calc' 0 = ""
  | calc' i = ",2" ^ (calc' (i-1))
fun calculate_prefix 0 _ = "2"
  | calculate_prefix i ende = "1" ^ (calc' (i-1)) ^ (if ende then "" else ",1")

fun main(goal, i) =
    let 
	val _ = if (i < 0) then raise Error("Premise Nr. " ^ Int.toString(i) ^ " not found!\n") else ()
	val pter = Goal.get_first_goal(goal)
	val (left,right) = ( case pter of
			    IMP(a,b) => (a,b)
			  | _ => raise Error("Term not in implicative form") )
				

	val maps = ( Goal.freemapi2s(goal) , Goal.bndmapi2s(goal) )
   
	val subterm = ( if (i > 0) then (get_premisse left i) else right )
	    handle internalerror => 
		raise Error ("Premise Nr. " ^ Int.toString(i) ^ " not found!\n")
		    
	val ende = (get_premisse left (i+1) ; false) handle internalerror => true
	    
	val prefix = ( case left of
		      (C "TRUE") => "0"
		    | _ => calculate_prefix i ende   )

	val s    = javainput (subterm) 0 maps initvmap
	    
	(* val _ = print ("Term : \n" ^ s ^ "\n" ^ "Prefix :" ^ prefix ^ "\n")  *)
	val _ = print ("Rufe externes Programm JavaPos auf\n")

	val _ = system ("java -jar " ^ Paths.position_path ^ "Position.jar \""^s^"\"" ^ " " ^ prefix);
    in
	()
    end
end