;;--------------------------------------------------------------------------;;
;;--------------------------------------------------------------------------;;
;;                      PARAMETER OUTLINE MODE
;;--------------------------------------------------------------------------;;


(setq nedpg-outline-title-regexp "\\((\\*[ \t\n]*title =\\)")
(setq nedpg-outline-section-regexp "\\((\\*\\*+\\)")
(setq nedpg-outline-save-regexp "\\((\\*#\\)")
(setq 
 nedpg-outline-theo-regexp 
 "\\((\\*lem\\)\\|\\((\\*prop\\)\\|\\((\\*fact\\)\\|\\((\\*theo\\)\\|\\((\\*def\\)\\|\\((\\*cst\\)")
(setq 
 nedpg-outline-theo2-regexp 
 "\\(lem\\)\\|\\(prop\\)\\|\\(fact\\)\\|\\(theo\\)\\|\\(def\\)\\|\\(cst\\)\\|\\(claim\\)\\|\\(new_\\)")

(setq 
  nedpg-outline-regexp 
  (concat 
   nedpg-outline-title-regexp "\\|" 
   nedpg-outline-section-regexp "\\|" 
   nedpg-outline-save-regexp "\\|" 
   nedpg-outline-theo-regexp "\\|" 
   nedpg-outline-theo2-regexp))

(setq nedpg-outline-heading-end-regexp "\\(\\*)[ \t]*\n\\)\\|\\(\\.[ \t]*\n\\)")

;(if nedpg-outline
;    (add-hook 'nedpg-mode-hook '(lambda()(outline-minor-mode 1)))
;  )

(defun nedpg-outline-level()
  "Find the level of current outline heading in some Nedpg libraries."
  (let ((retour 0))
    (save-excursion
      (cond ((looking-at nedpg-outline-title-regexp) 1)
	    ((looking-at nedpg-outline-section-regexp)
	     (min 6 (- (match-end 0) (match-beginning 0)))) ; valeur maxi 6
	    ((looking-at nedpg-outline-theo-regexp) 7)
	    ((looking-at  (concat nedpg-outline-save-regexp "\\|"
				 nedpg-outline-theo2-regexp )
			 ) 8)
	    )
      )))

(defun nedpg-setup-outline ()
  "Set up local variable for outline mode"
  (make-local-variable 'outline-heading-end-regexp)
  (setq outline-heading-end-regexp nedpg-outline-heading-end-regexp)
  (make-local-variable 'outline-regexp)
  (setq outline-regexp nedpg-outline-regexp)
  (make-local-variable 'outline-level)
  (setq outline-level 'nedpg-outline-level)
  (outline-minor-mode 1)
)

(provide 'nedpg-outline)